#ifndef PRINT_H
#define PRINT_H
#define REG_SCREEN_CTRL 0x3d4
#define REG_SCREEN_DATA 0x3d5

#include <stdbool.h>

enum {
    PRINT_COLOR_BLACK = 0,
	PRINT_COLOR_BLUE = 1,
	PRINT_COLOR_GREEN = 2,
	PRINT_COLOR_CYAN = 3,
	PRINT_COLOR_RED = 4,
	PRINT_COLOR_MAGENTA = 5,
	PRINT_COLOR_BROWN = 6,
	PRINT_COLOR_LIGHT_GRAY = 7,
	PRINT_COLOR_DARK_GRAY = 8,
	PRINT_COLOR_LIGHT_BLUE = 9,
	PRINT_COLOR_LIGHT_GREEN = 10,
	PRINT_COLOR_LIGHT_CYAN = 11,
	PRINT_COLOR_LIGHT_RED = 12,
	PRINT_COLOR_PINK = 13,
	PRINT_COLOR_YELLOW = 14,
	PRINT_COLOR_WHITE = 15,
};

typedef struct ansi_code_struct {
    int flag;
    int color;
} ansi_color_code_t;

const static int NUM_COLS = 80;
const static int NUM_ROWS = 25;

struct Char {
    char character;
    char color;
};

static bool is_parsing_ansi_string = false;
static bool ansi_string_found_bracket = false;

static bool ansi_string_found_semi = false;
static bool ansi_string_found_m = false;

static bool ansi_string_found_number = false;

static int _flag = 0;
static int _color = 0;

static int working_num = 0;

void clear_row(int row);
void clear_all();

void print_newline();
void print_char(char character);
void _print_char(char character);
void print_set_color(char foreground, char background);
void print_str(char* str);

void set_cursor_pos(int col, int row);

void kernel_msg_ok(char* msg);

void handle_ansi_code(ansi_color_code_t code);

#endif