#include <shade/platform/ports.h>
#include <shade/platform/drivers/vga_text_mode.h>
#include <shade/platform/interrupts/idt.h>
#include <shade/platform/interrupts/pic.h>
#include <printf.h>

void kernel_welcome() {
    printf("Welcome to ");
    print_set_color(PRINT_COLOR_CYAN, PRINT_COLOR_BLACK);
    printf("Shade");
	print_set_color(PRINT_COLOR_WHITE, PRINT_COLOR_BLACK);
    printf("!\nshadeOS kernel version ");
	print_set_color(PRINT_COLOR_YELLOW, PRINT_COLOR_BLACK);
	printf("0.2.2\n");
	print_set_color(PRINT_COLOR_WHITE, PRINT_COLOR_BLACK);
	printf("Running on ");
	print_set_color(PRINT_COLOR_YELLOW, PRINT_COLOR_BLACK);
	printf("shade-development\n");
    print_set_color(PRINT_COLOR_WHITE, PRINT_COLOR_BLACK);
}

// kMain
void kmain() {
    // Initialize screen buffer
	struct Char* buffer = (struct Char*) 0xb8000;
    
    clear_all(); // Clear screen
    set_cursor_pos(0, 0); // Set cursor position
    print_set_color(PRINT_COLOR_WHITE, PRINT_COLOR_BLACK); // Set print color

    // welcome messages
    kernel_msg_ok("Initialized display successfully\n");
    kernel_welcome();

    printf("Copyright (c) e3team 2022. All rights reserved.\n");
    printf("This program is provided \"as-is\" and no express or implied warranty is provided.\n");
    printf("The full license can be found at /sys/LICENCE on this system or ./LICENCE in the source tree.\n");

    pic_remap(0x20, 0x28);
    idt_assemble();
    kernel_msg_ok("Enabled interrupts\n");
    __asm__ __volatile__("int $2");

    printf("ANSI code test: double \x1b[3;31m \x1b[31m \x1b[12m \x1b[0m \x1b[3;31m \n");
    printf("ansi code test done\n");

    for (;;) {}
}